; basE91 encoder for DOS
; Copyright (c) 2000-2005 Joachim Henke

section .text

bits 16
cpu 386
org 256

	push word 0x5B00	; divisor
	push dword 0
	jmp lc4
lc1:
	cmp si, bp
	jnc lc3
lc2:
	xor eax, eax
	lodsb
	shl eax, cl
	add cl, 8
	or edx, eax
	cmp cl, 14	; enough bits in queue?
	jc lc1

	mov ax, 0x1FFF
	mov bl, cl
	and ax, dx
	xor cl, cl
	cmp ax, 89	; value in bit queue < 89?
	mov ax, 1
	adc cl, 13
	shl ax, cl	; create mask
	sub bl, cl
	dec ax
	and ax, dx
	div ch
	shr edx, cl
	mov cl, bl

	mov bl, ah
	mov ah, al
	mov al, [bx + enctab]
	mov bl, ah
	mov ah, [bx + enctab]
	stosw
	jmp lc1
lc3:
	push cx
	push edx

	mov cx, di
	mov dx, bufo
	mov ah, 0x40
	mov bl, 1
	sub cx, dx
	int 0x21	; write to standard output
lc4:
	mov ah, 0x3F
	xor bx, bx
	mov cx, 35840
	mov dx, bufi
	int 0x21	; read from standard input

	mov bp, dx
	mov di, bufo
	pop edx		; init bit queue
	cld
	mov si, bp
	pop cx
	add bp, ax
	test ax, ax	; 0 = EOF
	jnz lc2

	test cl, cl
	jz lc5
	mov ax, dx
	cmp dx, 91	; value in bit queue < 91?
	sbb dx, dx
	div ch
	cmp cl, 8	; less than 8 bits in queue?
	sbb cx, cx
	mov bx, enctab
	and cx, dx	; write 1 or 2 bytes
	xlat
	inc cx
	xchg al, ah
	mov dx, bufo
	inc cx
	xlat
	mov bx, 1
	stosw
	mov ah, 0x40
	int 0x21	; write to standard output
lc5:
	retn	; exit program

enctab:
	db 'ABCDEFGHIJKLM'
	db 'NOPQRSTUVWXYZ'
	db 'abcdefghijklm'
	db 'nopqrstuvwxyz'
	db '0123456789!#$'
	db '%&()*+,./:;<='
	db '>?@[]^_`{|}~"'


section .bss align=2

bufo:
	resb 29122
bufi:
	resb 35840
